function [ coeffsNotMod ] = firCoefficients( filterLength, amplitude)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here
    fileCoefficients = 'Coefficients.sv';
    
    moduli = [3 4 5 7 11];
    numberOfModuli = length(moduli);
    coefficients = [];
    
    coeffsNotMod = round(fir1(filterLength,0.5)*amplitude);
    for i = [1:numberOfModuli]
        coefficientsmod = mod(coeffsNotMod,moduli(i));
        coefficients = [coefficients; coefficientsmod];
    end

    file = fopen(fileCoefficients, 'w');
    for i = [1:numberOfModuli] 
        fprintf(file, 'localparam integer COEFFICIENTS%d [%d :0] = {', moduli(i), filterLength);
        for j = [1:filterLength + 1]
            fprintf(file, ' %d', coefficients(i,j));
            if(j<=filterLength)
                fprintf(file, ',');
            end
        end
        fprintf(file, '};\n');
    end
    
    fprintf(file,'localparam integer FIR_COEFFICIENTS [%d-1 :0] [%d:0] = {', length(moduli), filterLength);
    for i =[1:numberOfModuli]
        fprintf(file,' COEFFICIENTS%d', moduli(i));
        if(i<numberOfModuli)
            fprintf(file, ',');
        end
    end
    fprintf(file, '};\n');
end

