function [ coeffsNotMod ] = firCoefficientsQuad( filterLength, amplitude)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here
    fileCoefficients = 'CoefficientsQuad.sv';
    
    moduli = [13 17 37];
    Jmod =[8 4 6];
    numberOfModuli = length(moduli);
    coefficients = [];
    
    coeffsNotMod = round(fir1(filterLength,0.5)*amplitude);
    for i = [1:numberOfModuli]
        coefficientsmod = mod(coeffsNotMod,moduli(i));
        coefficients = [coefficients; coefficientsmod];
    end

    file = fopen(fileCoefficients, 'w');
    for i = [1:numberOfModuli] 
        fprintf(file, 'localparam integer COEFFICIENTS_N%d [%d :0] = {', moduli(i), filterLength);
        for j = [1:filterLength + 1]
            fprintf(file, ' %d', mod(coefficients(i,j)+Jmod(i)*coefficients(i,j), moduli(i)));
            if(j<=filterLength)
                fprintf(file, ',');
            end
        end
        fprintf(file, '};\n');
    end
    
    fprintf(file,'localparam integer FIR_COEFFICIENTS_N [%d-1 :0] [%d:0] = {', length(moduli), filterLength);
    for i =[1:numberOfModuli]
        fprintf(file,' COEFFICIENTS_N%d', moduli(i));
        if(i<numberOfModuli)
            fprintf(file, ',');
        end
    end
    
    fprintf(file, '};\n');
    
    for i = [1:numberOfModuli] 
        fprintf(file, 'localparam integer COEFFICIENTS_T%d [%d :0] = {', moduli(i), filterLength);
        for j = [1:filterLength + 1]
            fprintf(file, ' %d', mod(coefficients(i,j)-Jmod(i)*coefficients(i,j), moduli(i)));
            if(j<=filterLength)
                fprintf(file, ',');
            end
        end
        fprintf(file, '};\n');
    end
    
    fprintf(file,'localparam integer FIR_COEFFICIENTS_T [%d-1 :0] [%d:0] = {', length(moduli), filterLength);
    for i =[1:numberOfModuli]
        fprintf(file,' COEFFICIENTS_T%d', moduli(i));
        if(i<numberOfModuli)
            fprintf(file, ',');
        end
    end
    
    fprintf(file, '};\n');
end

