LENGTH_OF_COEFFICIENTS = 128;
LENGTH_OF_SIGNAL = 1000;
AMPLITUDE = 30;
PERIOD = 8;
FILE_SIGNAL = 'signal.v';
FILE_RESULTS = 'results.v';



signal = round(wgn(LENGTH_OF_SIGNAL,2,14));


for i = 1:LENGTH_OF_SIGNAL
    for j = 1:2
        if signal(i,j) > 30
            signal(i,j) = 30;
        end
        if signal(i,j) < -30
            signal(i,j) = -30;
        end
    end
end

signal_file = fopen(FILE_SIGNAL, 'w');
results_file = fopen(FILE_RESULTS, 'w');



fprintf(signal_file, 'initial\n');
fprintf(signal_file, 'begin\n');
for i = 0:LENGTH_OF_SIGNAL-1
    fprintf(signal_file, 'stimuliI[%d] = %d;\n', i, signal(i+1,1));
    fprintf(signal_file, 'stimuliQ[%d] = %d;\n', i, signal(i+1,2));
end
fprintf(signal_file, 'end');


coefficients = firCoefficients(15,256);
sumr = [0];
sumi = [0];
prodr = zeros(128,1);
prodi = zeros(128,1);
powr = zeros(128,1);
match = [];
for i  = -16 : 984
    for j = 1:16
        multiplicandr = 0;
        multiplicandi = 0;
        if i+j <= 0
            multiplicandr = 0;
            multiplicandi = 0;
        else
            multiplicandr = signal(i+j,1);
            multiplicandi = signal(i+j,2);
        end
        prodr(j) = coefficients(j)*multiplicandr;
        prodi(j) = coefficients(j)*multiplicandi;
    end
    sumr = [sumr sum(prodr)];
    sumi = [sumi sum(prodi)];
end


fprintf(results_file, 'initial\n');
fprintf(results_file, 'begin\n');
for i = 0:LENGTH_OF_SIGNAL
    fprintf(results_file, 'corrI[%d] = %d;\n', i, sumr(i+1));
    fprintf(results_file, 'corrQ[%d] = %d;\n', i, sumi(i+1));
end
fprintf(results_file, 'end');

