//====================================================================  
//        Copyright (c) 2015 Nordic Semiconductor ASA, Norway           
//====================================================================  
// Created       : eify at 03-24-16                                 
// Modified      : $Author$ $Date$                                      
// Version       : $Revision$ $HeadURL$                                 
//====================================================================  

module test_Receiver24bits (
  
  );

  localparam integer MODULI [4:0] = {3,4,5,7,11};

  int   errorCnt; //total error count
  int   errorCntTb; //Error count of tb
  int   errorCntAssertion; //Error count assertion
  logic [11:0] signalInI,signalInQ;
  logic [23:0] signalOutI, signalOutQ;
  logic ck;
  // -- Interfaces and signals
  inTest_Receiver24bits uin_Receiver24bits();
  `include "../../rtl/Coefficients.sv"
  `include "../../rtl/NumberOfTaps.sv"
  
  logic [11:0] coefficients [NUMBER_OF_TAPS - 1:0];
  
  assign coefficients = $signed(COEFFICIENTS[NUMBER_OF_TAPS-1: 0]);
  

//  Receiver24bits #(.NUMBER_OF_MODULI(5),.MODULI(MODULI)) u_Receiver24bits(signalInI, signalInQ, coefficients, ck, signalOutI, signalOutQ);
  Receiver24bits u_Receiver24bits(signalInI, signalInQ, (12*NUMBER_OF_TAPS)'(coefficients), ck, signalOutI, signalOutQ);

  // ------------------------------
  // -- Clock and Reset  
  // ------------------------------
  
  initial begin
    uin_Receiver24bits.arst = 0;
  end
  
  initial begin
    uin_Receiver24bits.clockEnable = 0;
  end
  
  //int cnt;
//-------------------------------------------------------------------------------------------------
//                Output simulation format/results
//-------------------------------------------------------------------------------------------------
  initial
  begin
    $timeformat(-6, 3, "us", 0);
  end   


  // ------------------------------
  // -- DUT and assignments  
  // ------------------------------
  

  logic [23:0] reffQ, reffI;
  assertionsReceiver24bits u_assertionsReceiver24bits(signalOutI, signalOutQ, reffI, reffQ, ck, errorCnt);
  // ------------------------------
  // -- Concurrent assertions
  // ------------------------------
  
  //-- Clocks and reset
  
  // ------------------------------
  // -- Test program  
  // ------------------------------
  //-------------------------------------------------------------------------------------------------
//                Main Stimulus
//-------------------------------------------------------------------------------------------------

logic [23:0] stimuliI [999:0];
logic [23:0] stimuliQ [999:0];
logic [23:0] corrI [1000:0];
logic [23:0] corrQ [1000:0];
`include "signal.v"
`include "results.v"

int i = 0;
initial begin
  @(posedge ck)
  for(i = 1;i <4096; i++) begin
    @(posedge ck);
  end

  fu_printEndStatus();
  $stop;
end


initial begin 
  ck <= 0;
  while(1) begin
    #50;
    ck = ~ck;
  end
end


assign signalInI = stimuliI[i];
assign signalInQ = stimuliQ[i];
assign reffQ = corrQ[i+2];
assign reffI = corrI[i+2];

function void fu_printEndStatus;
    $display("");
    $display("");
    $display($time, " ns:");
    $display("--------------------------------------------------------------------------------");
    $display("--------------------------------------------------------------------------------");
    $display("");
    $display("  SIMULATIONS FINISHED WITH %0d ERROR(S).", errorCnt);
    $display("");
    $display("");
    $display("      -> Check functional coverage.");
    $display("");
    $display("--------------------------------------------------------------------------------");
    $display("--------------------------------------------------------------------------------");
    $display("");
    $display("");
endfunction    

endmodule
