//====================================================================  
//        Copyright (c) 2015 Nordic Semiconductor ASA, Norway           
//====================================================================  
// Created       : eify at 03-24-16                                 
// Modified      : $Author$ $Date$                                      
// Version       : $Revision$ $HeadURL$                                 
//====================================================================  

module test_ReceiverQuad (
  
  );


  int   errorCnt; //total error count
  int   errorCntTb; //Error count of tb
  int   errorCntAssertion; //Error count assertion
  logic [11:0] signalInI,signalOutI, signalInQ, signalOutQ;
  logic ck;
  // -- Interfaces and signals
  inTest_ReceiverQuad uin_ReceiverQuad();

  `include "../../rtl/CoefficientsQuad.sv"
  `include "../../rtl/NumberOfTaps.sv"
  
  logic [3:0] coeffMod13I [NUMBER_OF_TAPS -1:0];
  logic [4:0] coeffMod17I [NUMBER_OF_TAPS -1:0];
  logic [5:0] coeffMod37I [NUMBER_OF_TAPS -1:0];
  logic [3:0] coeffMod13Q [NUMBER_OF_TAPS -1:0];
  logic [4:0] coeffMod17Q [NUMBER_OF_TAPS -1:0];
  logic [5:0] coeffMod37Q [NUMBER_OF_TAPS -1:0];

  assign coeffMod13I = $unsigned(COEFFICIENTS_N13[NUMBER_OF_TAPS -1:0]);
  assign coeffMod17I = $unsigned(COEFFICIENTS_N17[NUMBER_OF_TAPS -1:0]);
  assign coeffMod37I = $unsigned(COEFFICIENTS_N37[NUMBER_OF_TAPS -1:0]);
  assign coeffMod13Q = $unsigned(COEFFICIENTS_T13[NUMBER_OF_TAPS -1:0]);
  assign coeffMod17Q = $unsigned(COEFFICIENTS_T17[NUMBER_OF_TAPS -1:0]);
  assign coeffMod37Q = $unsigned(COEFFICIENTS_T37[NUMBER_OF_TAPS -1:0]);

  ReceiverQuad u_ReceiverQuad(signalInI, signalInQ,coeffMod13I,coeffMod17I,coeffMod37I,coeffMod13Q,coeffMod17Q,coeffMod37Q, ck, signalOutI, signalOutQ);
//  ReceiverQuad u_ReceiverQuad(signalInI, signalInQ,(4*NUMBER_OF_TAPS)'(coeffMod13I),(5*NUMBER_OF_TAPS)'(coeffMod17I),(6*NUMBER_OF_TAPS)'(coeffMod37I),(4*NUMBER_OF_TAPS)'(coeffMod13Q),(5*NUMBER_OF_TAPS)'(coeffMod17Q),(6*NUMBER_OF_TAPS)'(coeffMod37Q), ck, signalOutI, signalOutQ);

  // ------------------------------
  // -- Clock and Reset  
  // ------------------------------
  
  initial begin
    uin_ReceiverQuad.arst = 0;
  end
  
  initial begin
    uin_ReceiverQuad.clockEnable = 0;
  end
  
  //int cnt;
//-------------------------------------------------------------------------------------------------
//                Output simulation format/results
//-------------------------------------------------------------------------------------------------
  initial
  begin
    $timeformat(-6, 3, "us", 0);
  end   


  // ------------------------------
  // -- DUT and assignments  
  // ------------------------------
  

  logic [11:0] reffQ, reffI;
  assertionsReceiverQuad u_assertionsReceiverQuad(signalOutI, signalOutQ, reffI, reffQ, ck, errorCnt);
  // ------------------------------
  // -- Concurrent assertions
  // ------------------------------
  
  //-- Clocks and reset
  
  // ------------------------------
  // -- Test program  
  // ------------------------------
  //-------------------------------------------------------------------------------------------------
//                Main Stimulus
//-------------------------------------------------------------------------------------------------

logic [11:0] stimuliI [999:0];
logic [11:0] stimuliQ [999:0];
logic [11:0] corrI [1000:0];
logic [11:0] corrQ [1000:0];
`include "signal.v"
`include "results.v"

int i = 0;
initial begin
  @(posedge ck)
  for(i = 1;i <4096; i++) begin
    @(posedge ck);
  end

  fu_printEndStatus();
  $stop;
end


initial begin 
  ck <= 0;
  while(1) begin
    #50;
    ck = ~ck;
  end
end


assign signalInI = stimuliI[i];
assign signalInQ = stimuliQ[i];
assign reffQ = corrQ[i+2];
assign reffI = corrI[i+2];

function void fu_printEndStatus;
    $display("");
    $display("");
    $display($time, " ns:");
    $display("--------------------------------------------------------------------------------");
    $display("--------------------------------------------------------------------------------");
    $display("");
    $display("  SIMULATIONS FINISHED WITH %0d ERROR(S).", errorCnt);
    $display("");
    $display("");
    $display("      -> Check functional coverage.");
    $display("");
    $display("--------------------------------------------------------------------------------");
    $display("--------------------------------------------------------------------------------");
    $display("");
    $display("");
endfunction    

endmodule
