//====================================================================  
//        Copyright (c) 2015 Nordic Semiconductor ASA, Norway           
//====================================================================  
// Created       : eify at 09-28-15                                 
// Modified      : $Author$ $Date$                                      
// Version       : $Revision$ $HeadURL$                                 
//====================================================================  


module CsAdder #( 
  parameter ADDER_WORD_WIDTH	  = pa_ReceiverQuad::ADDER_WORD_WIDTH 
  )(
  // The tre opperands a, b and c input signals
  input logic signed   [ADDER_WORD_WIDTH - 1:0]	a,
  input logic signed   [ADDER_WORD_WIDTH - 1:0]	b,
  input logic signed   [ADDER_WORD_WIDTH - 1:0]	c,	
  // Sum and carry from Csa
  output logic	       [ADDER_WORD_WIDTH - 1:0]	s,
  output logic	       [ADDER_WORD_WIDTH - 1:0]	cOut
  );

genvar i;
generate
  for(i = 0; i < ADDER_WORD_WIDTH; i++) begin: la_SumCarryCalculation
    assign s[i] = a[i] ^ b[i] ^ c[i];
    assign cOut[i] = (a[i] & b[i]) | (b[i] & c[i]) || (a[i] & c[i]);
  end: la_SumCarryCalculation 
endgenerate

endmodule
