//====================================================================  
//        Copyright (c) 2015 Nordic Semiconductor ASA, Norway           
//====================================================================  
// Created       : eify at 02-04-16                                 
// Modified      : $Author$ $Date$                                      
// Version       : $Revision$ $HeadURL$                                 
//====================================================================  


module Rns2QrnsConverter #(
  parameter WORD_LENGTH		= pa_ReceiverQuad::FIR_CELL_WORD_LENGTH,
  parameter MODULO		= pa_ReceiverQuad::FIR_CELL_MODULO,
  parameter J			= pa_ReceiverQuad::QRNS_J,
  parameter J_WORD_LENGTH	= pa_ReceiverQuad::QRNS_J_WORD_LENGTH
  )(
  input logic [WORD_LENGTH - 1:0] inI,
  input logic [WORD_LENGTH - 1:0] inQ,
  output logic [WORD_LENGTH - 1:0] OutN,
  output logic [WORD_LENGTH - 1:0] OutT
  );
  
  localparam IMAG = J;
  localparam IMAG_WORD_LENGTH = J_WORD_LENGTH;

  logic [WORD_LENGTH + IMAG_WORD_LENGTH -1: 0] OutNExp, OutTExp;  
  
  assign OutNExp = inI + IMAG*inQ; 
  assign OutTExp = inI - IMAG*inQ;

  InputConverter#(.WORD_LENGTH(WORD_LENGTH + IMAG_WORD_LENGTH),.MODULO(MODULO),.MODULO_WORD_LENGTH(WORD_LENGTH)) u_InputConverterN(OutNExp, OutN);
  InputConverter#(.WORD_LENGTH(WORD_LENGTH + IMAG_WORD_LENGTH),.MODULO(MODULO),.MODULO_WORD_LENGTH(WORD_LENGTH)) u_InputConverterT(OutTExp, OutT);

endmodule
