//********************************************************************************
//                                                                                
//       Nordic Semiconductor ASA, Otto Nielsens veg 12, N-7052, NORWAY           
//                                                                                
//********************************************************************************
// File type   : Verilog list file.
// Revision    : $Revision$
// URL         : $HeadURL$
// Date        : $Date$
// Author      : eify at 03-24-16
// Description :
//               Assertions file for Receiver16bits module 
//               
//                                               
//               Copyright (c) 2015 by Nordic Semiconductor ASA                   
//********************************************************************************
module assertionsReceiverQuad (
 input logic signed [15:0] inI, inQ, refI, refQ,
 input logic clk,
 output int errorCntOut
  );
  
int errorCnt = 0;
assert property(@(posedge clk) inI === refI)
  else begin
  errorCnt = errorCnt + 1;
  $display("Time %0t : Error inI is not equal refI", $time);
end


assert property(@(posedge clk) inQ === refQ)
  else begin
  errorCnt = errorCnt + 1;
  $display("Time %0t : Error inQ is not equal refQ",$time);
end

assign errorCntOut = errorCnt;
endmodule
